accumulo-notifications mailing list archives

Site index · List index
Message view « Date » · « Thread »
Top « Date » · « Thread »
From "Josh Elser (JIRA)" <j...@apache.org>
Subject [jira] [Commented] (ACCUMULO-3608) Restore backwards binary compatibility with version 1.6.z
Date Tue, 14 Apr 2015 17:40:12 GMT

    [ https://issues.apache.org/jira/browse/ACCUMULO-3608?page=com.atlassian.jira.plugin.system.issuetabpanels:comment-tabpanel&focusedCommentId=14494456#comment-14494456
] 

Josh Elser commented on ACCUMULO-3608:
--------------------------------------

I think this means the following is not binary compatible, but is source compatible (the {{#decode(byte[])}}
method was moved up to org.apache.accumulo.core.client.lexicoder.AbstractEncoder). I think
this is fine.

{noformat}
accumulo-core-1.6.2.jar, BigIntegerLexicoder.class
package org.apache.accumulo.core.client.lexicoder
BigIntegerLexicoder.decode ( byte[ ] b )  :  java.math.BigInteger
BigIntegerLexicoder.decode ( byte[ ] x0 )  :  Object 

accumulo-core-1.6.2.jar, DateLexicoder.class
package org.apache.accumulo.core.client.lexicoder
DateLexicoder.decode ( byte[ ] data )  :  java.util.Date
DateLexicoder.decode ( byte[ ] x0 )  :  Object 

accumulo-core-1.6.2.jar, DoubleLexicoder.class
package org.apache.accumulo.core.client.lexicoder
DoubleLexicoder.decode ( byte[ ] data )  :  Double
DoubleLexicoder.decode ( byte[ ] x0 )  :  Object 

accumulo-core-1.6.2.jar, IntegerLexicoder.class
package org.apache.accumulo.core.client.lexicoder
IntegerLexicoder.decode ( byte[ ] data )  :  Integer
IntegerLexicoder.decode ( byte[ ] x0 )  :  Object

accumulo-core-1.6.2.jar, ListLexicoder<LT.class
package org.apache.accumulo.core.client.lexicoder
ListLexicoder<LT.decode ( byte[ ] b )  :  java.util.List<LT>
ListLexicoder<LT.decode ( byte[ ] x0 )  :  Object

accumulo-core-1.6.2.jar, LongLexicoder.class
package org.apache.accumulo.core.client.lexicoder
LongLexicoder.decode ( byte[ ] data )  :  Long
LongLexicoder.decode ( byte[ ] x0 )  :  Object 

accumulo-core-1.6.2.jar, PairLexicoder<A,B>.class
package org.apache.accumulo.core.client.lexicoder
PairLexicoder<A,B>.decode ( byte[ ] data )  :  org.apache.accumulo.core.util.ComparablePair<A,B>
PairLexicoder<A,B>.decode ( byte[ ] x0 )  :  Object

accumulo-core-1.6.2.jar, ReverseLexicoder<T>.class
package org.apache.accumulo.core.client.lexicoder
ReverseLexicoder<T>.decode ( byte[ ] data )  :  T 

accumulo-core-1.6.2.jar, TextLexicoder.class
package org.apache.accumulo.core.client.lexicoder
TextLexicoder.decode ( byte[ ] data )  :  org.apache.hadoop.io.Text
TextLexicoder.decode ( byte[ ] x0 )  :  Object

accumulo-core-1.6.2.jar, UIntegerLexicoder.class
package org.apache.accumulo.core.client.lexicoder
UIntegerLexicoder.decode ( byte[ ] data )  :  Integer
UIntegerLexicoder.decode ( byte[ ] x0 )  :  Object

accumulo-core-1.6.2.jar, ULongLexicoder.class
package org.apache.accumulo.core.client.lexicoder
ULongLexicoder.decode ( byte[ ] data )  :  Long
ULongLexicoder.decode ( byte[ ] x0 )  :  Object

accumulo-core-1.6.2.jar, UUIDLexicoder.class
package org.apache.accumulo.core.client.lexicoder
UUIDLexicoder.decode ( byte[ ] b )  :  java.util.UUID
UUIDLexicoder.decode ( byte[ ] x0 )  :  Object

{noformat}

> Restore backwards binary compatibility with version 1.6.z
> ---------------------------------------------------------
>
>                 Key: ACCUMULO-3608
>                 URL: https://issues.apache.org/jira/browse/ACCUMULO-3608
>             Project: Accumulo
>          Issue Type: Bug
>    Affects Versions: 1.7.0
>            Reporter: Sean Busbey
>            Priority: Blocker
>             Fix For: 1.7.0
>
>         Attachments: 1.6.2_to_1.7.0_compat_report.html, 1.7.0_to_1.6.2_compat_report.html,
compat_report.html
>
>
> We need to ensure that a check for binary backwards compatibility passes when comparing
1.6.z to current master, since it is only a minor version bump.
> {quote}
> That means new classes, interfaces,methods, enum members, etc are all fine. All of the
things labelled as HIGH severity in the binary compatibility report are definitely a problem.
They're mostly classes and methods that were removed.
> The end goal should be a report like the one Corey got for 1.6.1 -> 1.6.2. We don't
need the reciprocal report to be compatible because minor versions need not be forward compatible.
> Problems in the source compatibility report are worth reviewing, but things that only
show up there shouldn't be a blocker.
> {quote}
> There are instructions for running the compatibility checker in test/compat/japi-compliance/README



--
This message was sent by Atlassian JIRA
(v6.3.4#6332)

Mime
View raw message